/*
Copyright Renaud GICQUEL / Charles-Emile Hubert 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de calcul de la raction de reformage
 * 
 * @author Renaud GICQUEL
 */
public class Reformer extends ExtProcess implements Inversable
{
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField Tcr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
    
    double Tamont, Taval, Pamont, Paval,Hamont;
    Vector inputComp;
    Vector outputComp;
    double fractH2O,fractCO,fractH2,fractCO2,fractCH4,fractC2H6,inert;
    double x,K,K1a,a,b,F,d,SC,T,w;
    double alpha,beta,lambda,gamma;
    
    public Reformer (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("Tcr (C)");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(Tcr_value);
		Tcr_value.setBounds(164,0,100,20);
		Tcr_value.setText("650");
		JLabel2.setText("");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,80,300,20);

		type=getCompType();
   		thermoCouplerTypes=new String[1];//one thermocoupler connected
 		thermoCouplerTypes[0]="thermal load";
    }
    
    public String getCompType(){
        return "CH4 reformer";
    }
    
  	public String getClassDescription(){
	    return "CH4 reformer (with thermocoupler)\n\nauthors : C. E. Hubert / R. Gicquel  march 2005\n\nRef : archive Reformer.zip";
	}
    
    protected double getKp2(double T){
        double lnKp = -3.5741372 + 3642.4848/T   + 292592.85/T/T; //T en K. valeurs perso pour les paramtres
        // optimiss pour le domaine 600  700 C (cart rel.<0,05 %)
        // entre 500 et 800C : cart rel. <0.8 % et entre 400 et 900C : cart rel. <2%
        return Math.exp(lnKp);
    }
    protected double getKp1a(double T){
        double lnKp = 31.01522343 -28357.70472/T + 610573.0817/T/T;//valeurs perso pour les paramtres
        // optimiss pour le domaine 600  700 C (cart rel.<0,02 %)
        // entre 550  1050 C : cart rel.<0.2 %
        return Math.exp(lnKp);
    }
 
    public void init(){
	    calculateProcess();
    }
   
	public void calculateProcess(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        String aval=(String)vProp.elementAt(2);//gets the downstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Pamont=Ppoint;
        Hamont=Hpoint;
        getSubstProperties(nomCorps);
        double Q0;
        if(typeSubst==4){//le corps d'entre est un gaz compos
            
            //initialisations pour la dtermination de la raction
            inputComp=lecorps.getGasComposition();
            fractH2O=Util.molarComp(inputComp,"H2O");
            fractCH4=Util.molarComp(inputComp,"CH4 ` mthane");
            fractC2H6=Util.molarComp(inputComp,"C2H6 ` thane");
            fractH2=Util.molarComp(inputComp,"H2");
            fractCO2=Util.molarComp(inputComp,"CO2");
            inert=1.-fractH2O-fractCO-fractH2-fractCO2;
	        if(fractCH4*fractH2O!=0){//le gaz en entre contient CH4 et H2O
	            double debMoltot=flow/Msubst;
	            double debMolH2O=debMoltot*fractH2O;
	            F=debMoltot-debMolH2O;
	            SC=debMolH2O/F;
	            a=fractCH4*(1+SC);
	            b=fractC2H6*(1+SC);
	            d=fractCO2*(1+SC);
	            w=b*F;
	            T=Util.lit_d(Tcr_value.getText())+273.15;
                lecorps.CalcPropCorps(T,Pamont, 1);
                getSubstProperties(nomCorps);
                Q0=(Hsubst-Hamont)*flow;
	            K=getKp2(T);
	            K1a=getKp1a(T);
	            
	            double ymax=getY(a*F);//borne suprieure de recherche
                double y=Util.dicho_T (this,0.,1., "calcReformate",0.9*ymax,ymax,0.0001);//calcul de y
	            
//	            System.out.println("a  : "+a+"  b : "+b+"  d : "+d+"  K : "+K+"  K1a : "+K1a);
//	            System.out.println("F  : "+F+"  SC : "+SC+"  y : "+y+"  x : "+x+"  Q0 : "+Q0);
                
		        JLabel2.setText("F  : "+Util.aff_d(F,5)+"  SC : "+Util.aff_d(SC,2)+"  y : "+Util.aff_d(y,5)+"  x : "+Util.aff_d(x,5));
                
                double Fh2=3*x+5*w+y;
                double Fco=x+2*w-y;
                double Fch4=a*F-x;
                double Fh2o=SC*F-x-2*w-y;
                double Fco2=y+d*F;
                double Ftot=(1+SC)*F+2*x+4*w;
                double Fn2=Ftot-Fh2-Fco-Fch4-Fh2o-Fco2;
	
	            double xCO=Fco/Ftot;
	            double xCO2=Fco2/Ftot;
	            double xH2=Fh2/Ftot;
	            double xCH4=Fch4/Ftot;
	            double xH2O=Fh2o/Ftot;
	            double xN2=Fn2/Ftot;
                
   //             System.out.println("xCO  : "+xCO+"  xCO2 : "+xCO2+"  xH2 : "+xH2+"  xCH4 : "+xCH4+"  xH2O : "+xH2O+"  xN2 : "+xN2);
                
                outputComp=new Vector();
                int nComp=6;
                String[] Comp= new String[nComp];
                Double[]fracMol= new Double[nComp];
                Double[]fracMass= new Double[nComp];
                Comp[0]="CO";Comp[1]="CO2";Comp[2]="H2";Comp[3]="CH4 ` mthane";Comp[4]="H2O";Comp[5]="N2";
                fracMol[0]=new Double(xCO);
                fracMol[1]=new Double(xCO2);
                fracMol[2]=new Double(xH2);
                fracMol[3]=new Double(xCH4);
                fracMol[4]=new Double(xH2O);
                fracMol[5]=new Double(xN2);
                fracMass[0]=new Double(xCO);
                fracMass[1]=new Double(xCO2);
                fracMass[2]=new Double(xH2);
                fracMass[3]=new Double(xCH4);
                fracMass[4]=new Double(xH2O);
                fracMass[5]=new Double(xN2);
                outputComp.addElement(new Integer(6));
                outputComp.addElement(Comp);
                outputComp.addElement(fracMol);
                outputComp.addElement(fracMass);
                outputComp.addElement(new Double(1.));

                getPointProperties(aval);//direct parsing of point property vector
                lecorps.updateGasComposition(outputComp);
                getSubstProperties(nomCorps);
                Tpoint=T;    
                tfe.setupPointAval(getProperties());//mise  jour de la transfo et du point aval

                double Q=(206*x+347*w-41.2*y)*1000+Q0;
	            updateThermoCoupler("thermal load", T, T, Q, flow,true,10);

	        }
	        else{//le gaz en entre ne contient pas de CH4 ou pas de H2O
	            String msg = "Error: the inlet gas dos not include CH4 or H2O";
	            JOptionPane.showMessageDialog(tfe, msg);  
	        }
	    }
	    else{//le corps d'entre n'est pas un gaz compos
	        String msg = "Error: the inlet substance is not a compound gas";
	        JOptionPane.showMessageDialog(tfe, msg);  
	    }
	}
	
    
    
    /**
    * mthode gnrique d'inversion
    * 
    */
    public double f_dicho(double y, double T,String fonc){
        
        if (fonc.equals("calcReformate"))return calcReformate(y);

        return 0;
    }

	
    /**
    * calcul de x en fonction de y (quation 7) 
    * 
    */
	protected double getX(double y){
        double delta;
        delta=4*K*b*F*F*d+4*K*b*F*y+9*d*d*F*F+18*d*F*y-6*d*F*F*K*SC+9*y*y
            -6*K*y*SC*F+K*K*SC*SC*F*F-4*K*K*y*SC*F+4*K*K*y*y-4*K*y*y-4*K*d*F*y;
        if(delta<0)delta=0;
        return(-4*K*b*F-3*d*F-3*y+K*SC*F-Math.pow(delta,0.5))/2./K;
	}

	
    /**
    * calcul de y en fonction de x (quation 7) 
    * 
    */
	protected double getY(double x){
        double delta;
        delta=K*K*SC*SC*F*F+18*K*b*F*F*SC+10*K*x*SC*F+2*K*SC*F*F*d+25*b*b*F*F+30*x*b*F-10*d*F*F*b+9*x*x-6*d*F*x+d*d*F*F
        -4*K*x*x-16*K*x*b*F-16*K*b*b*F*F-4*K*K*x*SC*F+4*K*K*x*x+16*K*K*x*b*F-8*K*K*b*F*F*SC
        +16*K*K*b*b*F*F+12*K*d*F*x+20*K*d*F*F*b;
        if(delta<0)delta=0;
        return(K*SC*F+5*b*F+3*x+d*F-Math.pow(delta,0.5))/2./(K-1.);
	}
    /**
    * calcul du rsidu de l'quation 6 
    * 
    */
	protected double calcReformate(double y){
	    x=getX(y);
        double Fh2=3*x+5*w+y;
        double Fco=x+2*w-y;
        double Fch4=a*F-x;
        double Fh2o=SC*F-x-2*w-y;
        double Ftot=(1+SC)*F+2*x+4*w;
        double res=K1a-Pamont*Pamont*Fh2*Fh2*Fh2*Fco/Fch4/Fh2o/Ftot/Ftot;
        return res;
            
	}
    
	public void readCompParameters(String ligne_data){
	    double value=900;
        String valeur=Util.extr_value(ligne_data, "Tcr_value");
        if(valeur!=null)value=Util.lit_d(valeur);
	    Tcr_value.setText(Util.aff_d(value,3));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"Tcr_value="+Tcr_value.getText()+tab
	    ;
        return h;
    }
 

}